/*
############################################################
"colormsg" command
broadcast a color message
use [red] [green] etc to add color codes to message
requires marshal privilege
example: colormsg [red]RED ALERT!
############################################################
*/
function is_marshal(slot) {
	var rank;

	rank = mxserver.get_string("rank", slot);

	return (rank == "Marshal" || rank == "Admin")
}

function convert_to_ansi(s) {
	var colors = {
		normal: "\x1b[0m",
		bright: "\x1b[1m",
		black: "\x1b[30m",
		red: "\x1b[31m",
		green: "\x1b[32m",
		yellow: "\x1b[33m",
		blue: "\x1b[34m",
		magenta: "\x1b[35m",
		cyan: "\x1b[36m",
		white: "\x1b[37m",
	};

	return s.replace(/\[([^}]+)\]/g, function (full, sub1) { if (sub1 in colors) return colors[sub1]; return full });
}

function broadcast_color_message(slot, msg) {
	if (!is_marshal(slot)) {
		mxserver.send(slot, "Permission denied");
		return;
	}
	mxserver.broadcast(convert_to_ansi(msg) + convert_to_ansi("[normal]"));
}

function colormsg(slot, cmdline) {
	var m, cmd, args;

	if (cmdline.match(/^\s*colormsg\b/) == null)
		return colormsg_prev(slot, cmdline);

	m = cmdline.match(/^\s*colormsg\s*(.*)/);

	broadcast_color_message(slot, m[1]);

	return 1;
}

var colormsg_prev = mxserver.command_handler;
mxserver.command_handler = colormsg;
